local function BattleTimer_OnLoad()
	BattleTimer_CombatTimerRunning = false;
	BattleTimer_CombatTimer = 0.0;
	BattleTimer_TotalCombatTimer = 0.0;
	BattleTimer_InstanceTimerRunning = false;
	BattleTimer_InstanceTimer = 0.0;
	BattleTimer_AutoReport = false;
	BattleTimer_AutoStart = true;
	BattleTimer_AutoCombatLog = false;
	
	SLASH_BATTLETIMER1 = "/btimer";
	SLASH_BATTLETIMER2 = "/bt";
	SlashCmdList["BATTLETIMER"] = BattleTimer_Command;
	
	DEFAULT_CHAT_FRAME:AddMessage("Battle Timer loaded.");
end

local function BattleTimer_TimeDivision(seconds)
	local totalSeconds = ceil(seconds);
	local minutes = floor(totalSeconds / 60);
	local seconds = totalSeconds % 60;
	return minutes, seconds
end

function BattleTimer_ReportToChat(channel,msgType)
	if (BattleTimer_CombatTimerRunning == true) then
		DEFAULT_CHAT_FRAME:AddMessage("Reporting will be available after leaving combat.",1.0,0.0,0.0);
	else
		local reportMessage = "";
		if ((BattleTimer_InstanceTimer == 0.0) and (BattleTimer_CombatTimer == 0.0)) then
			reportMessage = "No data to report.";
		elseif ((BattleTimer_InstanceTimer == 0.0) or (msgType == "last")) then
			local minutes, seconds = BattleTimer_TimeDivision(BattleTimer_CombatTimer);
			reportMessage = ("Last combat ended after " .. minutes .. " minute(s) and " .. seconds .. " second(s).")
		else
			local instanceMinutes, instanceSeconds = BattleTimer_TimeDivision(BattleTimer_InstanceTimer);
			local combatMinutes, combatSeconds = BattleTimer_TimeDivision(BattleTimer_TotalCombatTimer);
			reportMessage = ("Of the total " .. instanceMinutes .. " minutes this session, " .. combatMinutes .. " have been spent in combat. Downtime is " .. (instanceMinutes - combatMinutes) .. " minutes.");
		end
		if (channel == "LOCAL") then
			DEFAULT_CHAT_FRAME:AddMessage(reportMessage);
		else
			SendChatMessage(reportMessage,channel);
		end
	end
end

function BattleTimer_Command(command)
	if (command == "session start") then
		if (BattleTimer_InstanceTimerRunning == true) then
			DEFAULT_CHAT_FRAME:AddMessage("|c00FF0000A session timer is already running. Use the |rsession reset|c00FF0000 command to clear it.|r");
		else
			BattleTimer_InstanceTimer = 0.0;
			BattleTimer_TotalCombatTimer = 0.0;
			BattleTimer_InstanceTimerRunning = true;
			BattleTimer_CombatLogging(true);
			DEFAULT_CHAT_FRAME:AddMessage("Session timer started.",0.0,1.0,0.0);
		end
	elseif (command == "session reset") then 
		BattleTimer_InstanceTimerRunning = false;
		BattleTimer_InstanceTimer = 0.0;
		BattleTimer_TotalCombatTimer = 0.0;
		BattleTimer_CombatLogging(false);
		DEFAULT_CHAT_FRAME:AddMessage("Session timer reset.",0.0,1.0,0.0);
	elseif (command == "session stop") then
		if (BattleTimer_InstanceTimerRunning == false) then
			DEFAULT_CHAT_FRAME:AddMessage("No session timer is currently running.",1.0,0.0,0.0)
		else
			BattleTimer_InstanceTimerRunning = false;
			BattleTimer_CombatLogging(false);
			DEFAULT_CHAT_FRAME:AddMessage("Session timer stopped.",0.0,1.0,0.0)
		end
	elseif (command == "report") then
		BattleTimer_ReportToChat("LOCAL","");
	elseif (command == "report party") then
		BattleTimer_ReportToChat("PARTY","");
	elseif (command == "report raid") then
		BattleTimer_ReportToChat("RAID","");
	elseif (command == "report last") then
		BattleTimer_ReportToChat("LOCAL","last");
	elseif (command == "report last party") then
		BattleTimer_ReportToChat("PARTY","last");
	elseif (command == "report last raid") then
		BattleTimer_ReportToChat("RAID","last");
	elseif (command == "autoreport on") then
		BattleTimer_AutoReport = true;
		DEFAULT_CHAT_FRAME:AddMessage("Post-fight reporting on.",0.0,1.0,0.0);
	elseif (command == "autoreport off") then
		BattleTimer_AutoReport = false;
		DEFAULT_CHAT_FRAME:AddMessage("Post-fight reporting off.",0.0,1.0,0.0);
	elseif (command == "autostart on") then
		BattleTimer_AutoStart = true;
		DEFAULT_CHAT_FRAME:AddMessage("Session timer will start upon entering an instance.",0.0,1.0,0.0);
	elseif (command == "autostart off") then
		BattleTimer_AutoStart = false;
		DEFAULT_CHAT_FRAME:AddMessage("Session timer will not start automatically.",0.0,1.0,0.0);
	elseif (command == "autostart") then
		if (BattleTimer_AutoStart == true) then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFBattle Timer |rautostart |cFFFF00FFcommand usage:|r");
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFAutomatic session timing is currently |cFFFFE303on|cFFFF00FF.|r");
			DEFAULT_CHAT_FRAME:AddMessage("autostart |cFFFFE303on | off |cFFFF00FF- Enable or disable automatic session timing when entering a party/raid instance|r");
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFBattle Timer |rautostart |cFFFF00FFcommand usage:|r");
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFAutomatic session timing is currently |cFFFFE303off|cFFFF00FF.|r");
			DEFAULT_CHAT_FRAME:AddMessage("autostart |cFFFFE303on | off |cFFFF00FF- Enable or disable automatic session timing when entering a party/raid instance|r");
		end
	elseif (command == "combatlog on") then
		BattleTimer_AutoCombatLog = true;
		DEFAULT_CHAT_FRAME:AddMessage("Combat will automatically be logged while the session timer is active.",0.0,1.0,0.0);
	elseif (command == "autostart off") then
		BattleTimer_AutoCombatLog = false;
		DEFAULT_CHAT_FRAME:AddMessage("Combat will not automatically be logged.",0.0,1.0,0.0);
	elseif (command == "combatlog") then
		if (BattleTimer_AutoCombatLog == true) then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFBattle Timer |rcombatlog |cFFFF00FFcommand usage:|r");
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFCombat logging |cFFFFE303will|cFFFF00FF automatically start and stop with the session timer.|r");
			DEFAULT_CHAT_FRAME:AddMessage("combatlog |cFFFFE303on | off |cFFFF00FF- Automatically start and stop combat logging with the session timer|r");
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFBattle Timer |rcombatlog |cFFFF00FFcommand usage:|r");
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFCombat logging |cFFFFE303will not|cFFFF00FF automatically start and stop with the session timer.|r");
			DEFAULT_CHAT_FRAME:AddMessage("combatlog |cFFFFE303on | off |cFFFF00FF- Automatically start and stop combat logging with the session timer|r");
		end
	elseif (command == "autoreport") then
		if (BattleTimer_AutoReport == true) then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFBattle Timer |rautoreport |cFFFF00FFcommand usage:|r");
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFPost-fight reporting is currently |cFFFFE303on|cFFFF00FF.|r");
			DEFAULT_CHAT_FRAME:AddMessage("autoreport |cFFFFE303on | off |cFFFF00FF- Enable or disable post-fight reporting of the previous combat timer|r");
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFBattle Timer |rautoreport |cFFFF00FFcommand usage:|r");
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFAutoreporting is currently |cFFFFE303off|cFFFF00FF.|r");
			DEFAULT_CHAT_FRAME:AddMessage("autoreport |cFFFFE303on | off |cFFFF00FF- Enable or disable post-fight reporting of the previous combat timer|r");
		end
	elseif (command == "session") then
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFBattle Timer |rsession |cFFFF00FFcommand usage:|r");
		DEFAULT_CHAT_FRAME:AddMessage("session |cFFFFE303start | stop |cFFFF00FF- Start or stop the session timer|r");
	elseif (command == "version") then
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFBattle Timer 3.1.1 is currently installed.|r");
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFBattle Timer slash command usage:|r");
		DEFAULT_CHAT_FRAME:AddMessage("session |cFFFFE303start | stop |cFFFF00FF- Start or stop the session timer|r");
		DEFAULT_CHAT_FRAME:AddMessage("session reset |cFFFF00FF- Clear and stop the instance timer|r");
		DEFAULT_CHAT_FRAME:AddMessage("report |cFFFFE303[last] [party | raid] |cFFFF00FF- Prints the current session and downtime information (if available, or last combat information if specified), or relays the information to the party or raid channel (if specified)|r");
		DEFAULT_CHAT_FRAME:AddMessage("autoreport |cFFFFE303on | off |cFFFF00FF- Enable or disable post-fight reporting of the previous combat timer|r");
		DEFAULT_CHAT_FRAME:AddMessage("autostart |cFFFFE303on | off |cFFFF00FF- Enable or disable automatic session timing when entering a party/raid instance|r");
		DEFAULT_CHAT_FRAME:AddMessage("combatlog |cFFFFE303on | off |cFFFF00FF- Automatically start and stop combat logging with the session timer|r");
	end
end


local frame = CreateFrame("Frame");
local ldb = LibStub:GetLibrary("LibDataBroker-1.1");
local dataobj = ldb:NewDataObject("BattleTimer", {type = "data source", text = "0 Sec", label = "Battle Timer", icon = "Interface\\Icons\\INV_Misc_PocketWatch_02"});

local onEvent = function(self, event, ...)
	self[event](self,event,...);
end

local onUpdate = function(self, elapsed)
	if (BattleTimer_CombatTimerRunning == true) then
		BattleTimer_CombatTimer = BattleTimer_CombatTimer + elapsed;
	end
	if (BattleTimer_InstanceTimerRunning == true) then
		BattleTimer_InstanceTimer = BattleTimer_InstanceTimer + elapsed;
	end
	
	-- LDB Feed
	if (BattleTimer_CombatTimer > 0) then
		dataobj.text = SecondsToTime(BattleTimer_CombatTimer);
	end
end

function dataobj:OnTooltipShow()
	self:AddLine("Battle Timer:");
	if (BattleTimer_InstanceTimerRunning) then
		self:AddLine("Session timer running.");
		self:AddLine("Current session: "..SecondsToTime(BattleTimer_InstanceTimer,false));
		if (BattleTimer_CombatTimerRunning == false) then
			self:AddLine("Total combat: "..SecondsToTime(BattleTimer_TotalCombatTimer,false));
		end
	else
		self:AddLine("Session timer stopped.");
	end
end

frame:SetScript("OnEvent", onEvent);
frame:SetScript("OnUpdate", onUpdate);

function BattleTimer_CombatLogging(start)
	if (start) then
		if ((BattleTimer_AutoCombatLog) and (not LoggingCombat())) then
			LoggingCombat(1);
			DEFAULT_CHAT_FRAME:AddMessage("Combat logging enabled.",0.0,1.0,0.0);
		end
	else
		if ((BattleTimer_AutoCombatLog) and (LoggingCombat())) then
			LoggingCombat(0);
			DEFAULT_CHAT_FRAME:AddMessage("Combat logging disabled.",0.0,1.0,0.0);
		end
	end
end

function frame:PLAYER_REGEN_DISABLED(event)
	BattleTimer_CombatTimer = 0.0;
	BattleTimer_CombatTimerRunning = true;
end

function frame:PLAYER_REGEN_ENABLED(event)
	BattleTimer_CombatTimerRunning = false;
	BattleTimer_TotalCombatTimer = BattleTimer_TotalCombatTimer + BattleTimer_CombatTimer;
	if (BattleTimer_AutoReport == true) then
		BattleTimer_ReportToChat("LOCAL","last");
	end
end

function frame:PLAYER_ENTERING_WORLD(event)
	if ((BattleTimer_InstanceTimerRunning == false) and (BattleTimer_AutoStart == true)) then
		local inInstance, instanceType = IsInInstance()
		if (inInstance and (instanceType == ("party" or "raid"))) then
			BattleTimer_InstanceTimer = 0.0;
			BattleTimer_TotalCombatTimer = 0.0;
			BattleTimer_InstanceTimerRunning = true;
			DEFAULT_CHAT_FRAME:AddMessage("Session timer automatically started.",0.0,1.0,0.0);
			BattleTimer_CombatLogging(true);
		end
	end
end


BattleTimer_OnLoad()
frame:RegisterEvent("PLAYER_REGEN_DISABLED");
frame:RegisterEvent("PLAYER_REGEN_ENABLED");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");